=== modified file 'oo4gl/Progress/Lang/Class.cls'
--- old/oo4gl/Progress/Lang/Class.cls	2020-05-20 11:34:22 +0000
+++ new/oo4gl/Progress/Lang/Class.cls	2022-03-07 07:21:28 +0000
@@ -16,20 +16,20 @@
 
    /* the actual GetPropertyValue() return type is variable (it depends on the */
    /* property, but we are encoding it as Object until we have a better solution */
-   method public Progress.Lang.Object GetPropertyValue(input pname as character):
-   end.
-   
-    method public Progress.Lang.Object GetPropertyValue(input pname as character,
-      input index as Progress.Lang.Object):
-   end.
-   
-   method public Progress.Lang.Object GetPropertyValue(input obj-ref as Progress.Lang.Object, 
+   method public _polymorphic_ GetPropertyValue(input pname as character):
+   end.
+   
+   method public _polymorphic_ GetPropertyValue(input pname as character,
+      input index as _polymorphic_):
+   end.
+   
+   method public _polymorphic_ GetPropertyValue(input obj-ref as Progress.Lang.Object, 
       input pname as character):
    end.
    
-   method public Progress.Lang.Object GetPropertyValue(input obj-ref as Progress.Lang.Object, 
+   method public _polymorphic_ GetPropertyValue(input obj-ref as Progress.Lang.Object, 
       input pname as character,
-      input index as Progress.Lang.Object):
+      input index as _polymorphic_):
    end.
    
    method public static Progress.Lang.Class GetClass(input clsname as character):
@@ -50,19 +50,19 @@
    /* the actual Invoke() return type is variable (it depends on the */
    /* method invoked, but we are encoding it as Object until we have */
    /* a better solution */
-   method public Progress.Lang.Object Invoke(input obj-instance as Progress.Lang.Object,
+   method public _polymorphic_ Invoke(input obj-instance as Progress.Lang.Object,
                                              input method-name as character):
    end method.
    
-   method public Progress.Lang.Object Invoke(input obj-instance as Progress.Lang.Object,
+   method public _polymorphic_ Invoke(input obj-instance as Progress.Lang.Object,
                                              input method-name as character,
                                              input parm-list as Progress.Lang.ParameterList):
    end method.
    
-   method public Progress.Lang.Object Invoke(input method-name as character):
+   method public _polymorphic_ Invoke(input method-name as character):
    end method.
    
-   method public Progress.Lang.Object Invoke(input method-name as character,
+   method public _polymorphic_ Invoke(input method-name as character,
                                              input parm-list as Progress.Lang.ParameterList):
    end method.
    
@@ -179,22 +179,23 @@
    end method.
    
    method public void SetPropertyValue(input pname as character,
-      input value as Progress.Lang.Object):
+      input value as _polymorphic_):
    end.
    
-    method public void SetPropertyValue(input pname as character,
-      input index as Progress.Lang.Object,
-      input value as Progress.Lang.Object):
+   method public void SetPropertyValue(input pname as character,
+      input index as _polymorphic_,
+      input value as _polymorphic_):
    end.
    
    method public void SetPropertyValue(input obj-ref as Progress.Lang.Object, 
-      input pname as character, input value as Progress.Lang.Object):
+      input pname as character, 
+      input value as _polymorphic_):
    end.
    
    method public void SetPropertyValue(input obj-ref as Progress.Lang.Object, 
       input pname as character,
-      input index as Progress.Lang.Object,
-      input value as Progress.Lang.Object):
+      input index as _polymorphic_,
+      input value as _polymorphic_):
    end.
    
 end class.

=== modified file 'oo4gl/Progress/Lang/ParameterList.cls'
--- old/oo4gl/Progress/Lang/ParameterList.cls	2017-07-09 15:20:30 +0000
+++ new/oo4gl/Progress/Lang/ParameterList.cls	2022-03-07 07:21:46 +0000
@@ -17,7 +17,7 @@
    method public logical SetParameter(input idx as integer,
                                       input dtype as character,
                                       input pmode as character,
-                                      input parm-val as Progress.Lang.Object):
+                                      input parm-val as _polymorphic_):
    end method.
    
 end class.

=== modified file 'oo4gl/Progress/Reflect/AccessMode.cls'
--- old/oo4gl/Progress/Reflect/AccessMode.cls	2020-05-20 11:34:22 +0000
+++ new/oo4gl/Progress/Reflect/AccessMode.cls	2022-03-07 07:21:58 +0000
@@ -4,6 +4,8 @@
     define enum
         Public
         Protected
-        Private.
+        Private
+        Package-Protected
+        Package-Private.
    
 end enum.

=== modified file 'oo4gl/Progress/Reflect/Constructor.cls'
--- old/oo4gl/Progress/Reflect/Constructor.cls	2020-04-22 14:13:40 +0000
+++ new/oo4gl/Progress/Reflect/Constructor.cls	2022-03-07 07:22:09 +0000
@@ -12,7 +12,7 @@
   method public Progress.Reflect.Parameter EXTENT GetParameters():
   end.
 
-  method public Progress.Lang.Object Invoke( INPUT params AS Progress.Lang.ParameterList ):
+  method public _polymorphic_ Invoke( INPUT params AS Progress.Lang.ParameterList ):
   end.
 
 end.

=== modified file 'oo4gl/Progress/Reflect/Flags.cls'
--- old/oo4gl/Progress/Reflect/Flags.cls	2020-05-03 18:42:35 +0000
+++ new/oo4gl/Progress/Reflect/Flags.cls	2022-03-07 07:22:21 +0000
@@ -6,7 +6,9 @@
         Private
         Static
         Instance
-        DeclaredOnly.
+        DeclaredOnly
+        Package-Protected
+        Package-Private.
    
 end enum.
 

=== modified file 'oo4gl/Progress/Reflect/Method.cls'
--- old/oo4gl/Progress/Reflect/Method.cls	2020-05-20 11:34:22 +0000
+++ new/oo4gl/Progress/Reflect/Method.cls	2022-03-07 07:22:34 +0000
@@ -28,10 +28,10 @@
   method public Progress.Reflect.Parameter EXTENT GetParameters():
   end.
 
-  method public Progress.Lang.Object Invoke( INPUT params AS Progress.Lang.ParameterList ):
+  method public _polymorphic_ Invoke( INPUT params AS Progress.Lang.ParameterList ):
   end.
 
-  method public Progress.Lang.Object Invoke( INPUT instance AS Progress.Lang.Object, INPUT params AS Progress.Lang.ParameterList ):
+  method public _polymorphic_ Invoke( INPUT instance AS Progress.Lang.Object, INPUT params AS Progress.Lang.ParameterList ):
   end.
 
 end.

=== modified file 'oo4gl/Progress/Reflect/Variable.cls'
--- old/oo4gl/Progress/Reflect/Variable.cls	2020-04-22 14:13:40 +0000
+++ new/oo4gl/Progress/Reflect/Variable.cls	2022-03-07 07:23:53 +0000
@@ -17,37 +17,37 @@
 
    define public property OriginatingClass as Progress.Lang.Class get.
 
-   method public Progress.Lang.Object EXTENT Get():
+   method public _polymorphic_ Get():
    end.
   
-   method public Progress.Lang.Object EXTENT Get(INPUT index AS INTEGER):
+   method public _polymorphic_ Get(INPUT index AS integer):
    end.
 
-   method public Progress.Lang.Object EXTENT Get(INPUT instance AS Progress.Lang.Object):
+   method public _polymorphic_ Get(INPUT instance AS Progress.Lang.Object):
    end.
   
-   method public Progress.Lang.Object EXTENT Get(
+   method public _polymorphic_ Get(
       INPUT instance AS Progress.Lang.Object,
       INPUT index AS INTEGER):
    end.
   
-   method public void Set( INPUT value AS Progress.Lang.Object ):
+   method public void Set( INPUT value AS _polymorphic_ ):
    end.
 
    method public void Set( 
       INPUT index AS INTEGER, 
-      INPUT value AS Progress.Lang.Object ):
+      INPUT value AS _polymorphic_ ):
    end.
   
    method public void Set( 
       INPUT instance AS Progress.Lang.Object, 
-      INPUT value AS Progress.Lang.Object ):
+      INPUT value AS _polymorphic_ ):
    end.
 
    method public void Set( 
       INPUT instance AS Progress.Lang.Object,
       INPUT index AS INTEGER, 
-      INPUT value AS Progress.Lang.Object ):
+      INPUT value AS _polymorphic_ ):
    end.
 
 end.