=== modified file 'build.xml'
--- old/build.xml	2021-08-12 12:04:04 +0000
+++ new/build.xml	2022-04-19 14:59:42 +0000
@@ -38,8 +38,9 @@
    <!-- set global properties for this build -->
    
    <property name="build.home"           value="${basedir}/build" />
+   <property name="cvt.home"             value="${basedir}/cvt" />
    <property name="dist.home"            value="${basedir}/distribution" /> 
-   <property name="data.home"            value="${basedir}/data" />
+   <property name="data.rel"             value="data" /> <!-- relative path to data folder -->
    <property name="src.home"             value="${basedir}/src" />
    <property name="srcnew.home"          value="${basedir}/srcnew" />
    <property name="lib.home"             value="${basedir}/lib" />
@@ -540,14 +541,9 @@
       </copy>
 
       <!-- Copy data/ from src to equivalent location in build -->
-      <copy todir="${build.home}/classes/data">
-         <fileset dir="${data.home}" includes="**/*.dict" />
-         <fileset dir="${data.home}" includes="**/*.p2o" />
-      </copy>
-
-      <!-- Copy data ASTs to equivalent location in build -->
-      <copy todir="${build.home}/classes">
-         <fileset dir="${data.home}" includes="**/*.dict, **/*.schema, **/*.p2o" />
+      <copy todir="${build.home}/classes/${data.rel}">
+         <fileset dir="${cvt.home}/${data.rel}" includes="*.dict" />
+         <fileset dir="${cvt.home}/${data.rel}" includes="*.p2o" />
       </copy>
    </target>
    
@@ -562,7 +558,7 @@
                      *.jasper
                      **.xml
                      cfg/**
-                     data/**
+                     ${data.rel}/**
                      **/*.png
                      **/*.jpg
                      **/*.bmp
@@ -613,17 +609,13 @@
       <!-- create the deploy lib folder -->
       <mkdir dir="${deploy.home}/lib"/>
       
-      <!-- create and populate the extension lib folder -->
-      <mkdir dir="${deploy.home}/lib/spi"/>
-      <copy file="${p2jlib.home}/fwdspi.jar" todir="${deploy.home}/lib/spi"/>
-      
       <!-- copy the required jars to the distribution directory -->
       <copy file="${build.home}/lib/${appname}.jar" todir="${deploy.home}/lib"/>
       
       <!-- Copy external jars -->
       <copy todir="${deploy.home}/lib">
         <!--  exclude the AspectJ tools -->
-        <fileset dir="${p2jlib.home}" excludes="aspectjtools.jar,fwdspi.jar"/>
+        <fileset dir="${p2jlib.home}" excludes="aspectjtools.jar"/>
       </copy>
    </target>
    
@@ -678,6 +670,7 @@
       <delete includeemptydirs="true" failonerror="false">
         <fileset dir="${src.home}" excludes="**/*" />
       </delete>
+      <delete dir="${cvt.home}"/>
       <delete dir="${basedir}/ddl"/>
       <delete dir="${basedir}/local"/>
       <delete dir="${basedir}/com"/>

=== modified file 'build_db.xml'
--- old/build_db.xml	2022-01-31 10:40:55 +0000
+++ new/build_db.xml	2022-04-19 14:59:42 +0000
@@ -32,10 +32,12 @@
             failonerror="true"
             dir="${basedir}" >
          <jvmarg value="-Xmx1g"/>
-         <jvmarg value="-Djava.locale.providers=SPI,JRE"/>
-         <jvmarg value="-Djava.ext.dirs=deploy/lib/spi"/>
+        <jvmarg value="-Djava.locale.providers=SPI,CLDR,COMPAT"/>
+        <jvmarg value="-Djava.system.class.loader=com.goldencode.asm.AsmClassLoader"/>
+<!--
+        <jvmarg value="-Djava.ext.dirs=deploy/lib/spi"/>
+-->
          <jvmarg value="-Dfile.encoding=UTF-8"/>
-         <jvmarg value="-Djava.system.class.loader=com.goldencode.asm.AsmClassLoader"/>
          <arg value ="-url"/>
          <arg value ="${sql.url.h2}"/>
          <arg value ="-user"/>
@@ -59,10 +61,9 @@
             failonerror="true"
             dir="${basedir}" >
          <jvmarg value="-Xmx1g"/>
-         <jvmarg value="-Djava.locale.providers=SPI,JRE"/>
-         <jvmarg value="-Djava.ext.dirs=deploy/lib/spi"/>
+         <jvmarg value="-Djava.locale.providers=SPI,CLDR,COMPAT"/>
+         <jvmarg value="-Djava.system.class.loader=com.goldencode.asm.AsmClassLoader"/>
          <jvmarg value="-Dfile.encoding=UTF-8"/>
-         <jvmarg value="-Djava.system.class.loader=com.goldencode.asm.AsmClassLoader"/>
          <arg value ="-d"/>
          <arg value ="2"/>
          <arg value ="dbName=${escaped.quotes}${db.name}${escaped.quotes}"/>
@@ -70,9 +71,10 @@
          <arg value ="url=${escaped.quotes}${sql.url.h2}${escaped.quotes}"/>
          <arg value ="uid=${escaped.quotes}${sql.user}${escaped.quotes}"/>
          <arg value ="pw=${escaped.quotes}${sql.user.pass}${escaped.quotes}"/>
+      	 <arg value ="dataPath=${escaped.quotes}${data.rel}/dump/hotel${escaped.quotes}"/>
          <arg value ="maxThreads=4"/>
          <arg value ="schema/import"/>
-         <arg value ="data/namespace/"/>
+         <arg value ="${data.rel}"/>
          <arg value ="${db.name}.p2o"/>
          <classpath refid="app.classpath"/>
       </java>
@@ -83,8 +85,7 @@
             failonerror="true"
             dir="${basedir}" >
          <jvmarg value="-Xmx1g"/>
-         <jvmarg value="-Djava.locale.providers=SPI,JRE"/>
-         <jvmarg value="-Djava.ext.dirs=deploy/lib/spi"/>
+         <jvmarg value="-Djava.locale.providers=SPI,CLDR,COMPAT"/>
          <jvmarg value="-Dfile.encoding=UTF-8"/>
          <arg value ="-url"/>
          <arg value ="${sql.url.h2}"/>
@@ -240,6 +241,7 @@
          <arg value ="url=${escaped.quotes}${sql.url.pg}${escaped.quotes}"/>
          <arg value ="uid=${escaped.quotes}${sql.user}${escaped.quotes}"/>
          <arg value ="pw=${escaped.quotes}${sql.user.pass}${escaped.quotes}"/>
+      	 <arg value ="dataPath=${escaped.quotes}data/dump/hotel${escaped.quotes}"/>
          <arg value ="maxThreads=4"/>
          <arg value ="schema/import"/>
          <arg value ="data/namespace/"/>

=== modified file 'deploy/server/server.sh'
--- old/deploy/server/server.sh	2021-07-29 12:20:48 +0000
+++ new/deploy/server/server.sh	2022-04-19 14:59:42 +0000
@@ -73,7 +73,7 @@
 sport=$(($portbase + $instance))
 iport="net:server:insecure_port="$(($portbase + $instance + $portstep))
 port="net:connection:secure=true net:server:secure_port=$sport $iport"
-spi="-Djava.locale.providers=SPI,JRE -Djava.ext.dirs=$(${prog} ${cpath} com.goldencode.util.PrintSystemProp java.ext.dirs):../lib/spi"
+spi="-Djava.locale.providers=SPI,CLDR,COMPAT"
 
 if [ $debug -eq 1 ]; then
    dtxt="-Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=$dport,server=y,suspend=$suspend" 