=== modified file 'test/com/goldencode/p2j/comauto/TestComObject.java'
--- test/com/goldencode/p2j/comauto/TestComObject.java	2021-11-26 20:14:59 +0000
+++ test/com/goldencode/p2j/comauto/TestComObject.java	2022-09-19 15:43:04 +0000
@@ -62,12 +62,11 @@
 */
 package com.goldencode.p2j.comauto;
 
-import static org.junit.Assert.*;
-import static org.junit.jupiter.api.Assertions.assertEquals;
 import static com.goldencode.p2j.comauto.ComObject.convertInputParameter;
+import static org.junit.jupiter.api.Assertions.*;
 
 import java.time.*;
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 import com.goldencode.p2j.util.*;
 

=== modified file 'test/com/goldencode/p2j/testing/AbstractFWDTest.java'
--- test/com/goldencode/p2j/testing/AbstractFWDTest.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/testing/AbstractFWDTest.java	2022-09-19 15:41:16 +0000
@@ -67,9 +67,9 @@
 */
 package com.goldencode.p2j.testing;
 
-import static org.junit.Assert.*;
+import static org.junit.jupiter.api.Assertions.*;
 
-import org.junit.function.*;
+import org.junit.jupiter.api.function.*;
 
 import com.goldencode.p2j.*;
 import com.goldencode.p2j.util.*;
@@ -93,10 +93,9 @@
        *        the argument for the code
        * @throws ErrorConditionException
        */
-      void run(final T arg)
-      throws ErrorConditionException;
+      void run(final T arg) throws ErrorConditionException;
    }
-   
+
    /**
     * A helper method to check that code throws the OE error 14312.
     * 
@@ -106,8 +105,7 @@
     *        the format to pass to the code
     *        
     */
-   public final static void assertMustThrowError14312(final ErrorCode code,
-            final String format)
+   public final static void assertMustThrowError14312(final ErrorCode code, final String format)
    {
       assertMustThrowError(code, 14312, "Too many 'S' characters in format \"%s\"", format,
                format);
@@ -123,8 +121,7 @@
     *        the format to pass to the code
     *        
     */
-   public final static void assertMustThrowError154(final ErrorCode code,
-            final String format)
+   public final static void assertMustThrowError154(final ErrorCode code, final String format)
    {
       assertMustThrowError(code, 154, "Date format %s is incomplete", format, format);
    }
@@ -138,8 +135,7 @@
     *        the format to pass to the code
     *        
     */
-   public final static void assertMustThrowError164(final ErrorCode code,
-            final String format)
+   public final static void assertMustThrowError164(final ErrorCode code, final String format)
    {
       assertMustThrowError(code, 164, "Character format %s is incomplete", format, format);
    }
@@ -155,8 +151,8 @@
     * @param offendingCharIndex
     *        the index of the offending character
     */
-   public final static void assertMustThrowError22(final ErrorCode code,
-            final String format, final int offendingCharIndex)
+   public final static void assertMustThrowError22(final ErrorCode code, final String format,
+            final int offendingCharIndex)
    {
       assertMustThrowError(code, 22, "Character number %d of format %s is invalid", format,
                offendingCharIndex, format);
@@ -174,8 +170,8 @@
     *        the value to format
     *        
     */
-   public final static void assertMustThrowError74(final ErrorCode code,
-            final String format, final String value)
+   public final static void assertMustThrowError74(final ErrorCode code, final String format,
+            final String value)
    {
       assertMustThrowError(code, 74, "Value %s cannot be displayed using %s", format, value,
                format);
@@ -189,8 +185,7 @@
     * @param format
     *        the format to pass to the code
     */
-   protected final static void assertMustThrowError148(final ErrorCode code,
-            final String format)
+   protected final static void assertMustThrowError148(final ErrorCode code, final String format)
    {
       assertMustThrowError(code, 148, "Numeric format %s provides for no digits", format, format);
    }
@@ -261,11 +256,11 @@
     * @param args
     *        other arguments if the message format expects them
     */
-   private final static void assertMustThrowErrorConditional(final ThrowingRunnable code,
+   private final static void assertMustThrowErrorConditional(final Executable code,
             final int errorCodeExpected, final String expectedMessageFormat, Object... args)
    {
-      final ErrorConditionException exc = assertThrows("Must throw",
-               ErrorConditionException.class, code);
+      final ErrorConditionException exc = assertThrows(ErrorConditionException.class, code,
+               "Must throw");
       final Throwable cause = exc.getCause();
       assertTrue(cause instanceof NumberedException);
       NumberedException numbered = (NumberedException) cause;

=== modified file 'test/com/goldencode/p2j/testing/FormatTestSuite.java'
--- test/com/goldencode/p2j/testing/FormatTestSuite.java	2021-04-28 15:57:14 +0000
+++ test/com/goldencode/p2j/testing/FormatTestSuite.java	2022-09-19 18:25:16 +0000
@@ -65,8 +65,7 @@
 */
 package com.goldencode.p2j.testing;
 
-import org.junit.runner.*;
-import org.junit.runners.*;
+import org.junit.platform.suite.api.*;
 
 import com.goldencode.p2j.ui.client.format.*;
 import com.goldencode.p2j.util.*;
@@ -74,22 +73,13 @@
 /**
  * Test suite for parsing 4gl formats.
  */
-@RunWith(Suite.class)
-@Suite.SuiteClasses({
-   TestLogicalSplitformat.class,
-   TestCharacterToStringFormatted.class,
-   TestCharacterFormatParser.class,
-   TestCharacterFormatter.class,
-   TestCharacterPreprocessFormatString.class,
-   TestCharacterValueOf.class,
-   TestDateFormatting.class,
-   TestDateFormatParse.class,
-   TestDatetimeFormatting.class,
-   TestDatetimeFormatParsing.class,
-   TestNumberTypeParseFormat.class,
-   TestRowid.class,
-   TestStringFormatParse.class
-})
+@Suite
+@SelectClasses(value = { TestLogicalSplitformat.class, TestCharacterToStringFormatted.class,
+         TestCharacterFormatParser.class, TestCharacterFormatter.class,
+         TestCharacterPreprocessFormatString.class, TestCharacterValueOf.class,
+         TestDateFormatting.class, TestDateFormatParse.class, TestDatetimeFormatting.class,
+         TestDatetimeFormatParsing.class, TestNumberTypeParseFormat.class, TestRowid.class,
+         TestStringFormatParse.class })
 public class FormatTestSuite
 {
    // empty

=== modified file 'test/com/goldencode/p2j/ui/client/format/TestDatetimeFormatParsing.java'
--- test/com/goldencode/p2j/ui/client/format/TestDatetimeFormatParsing.java	2021-11-25 18:47:40 +0000
+++ test/com/goldencode/p2j/ui/client/format/TestDatetimeFormatParsing.java	2022-09-19 15:52:03 +0000
@@ -64,11 +64,11 @@
 */
 package com.goldencode.p2j.ui.client.format;
 
-import static org.junit.Assert.*;
+import static org.junit.jupiter.api.Assertions.*;
 
 import java.lang.reflect.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 import com.goldencode.p2j.util.*;
 

=== modified file 'test/com/goldencode/p2j/ui/client/format/TestStringFormatParse.java'
--- test/com/goldencode/p2j/ui/client/format/TestStringFormatParse.java	2021-04-08 18:56:52 +0000
+++ test/com/goldencode/p2j/ui/client/format/TestStringFormatParse.java	2022-09-19 15:52:47 +0000
@@ -65,9 +65,9 @@
 */
 package com.goldencode.p2j.ui.client.format;
 
-import static org.junit.Assert.assertNotNull;
+import static org.junit.jupiter.api.Assertions.assertNotNull;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 import com.goldencode.p2j.util.*;
 

=== modified file 'test/com/goldencode/p2j/util/AbstractCharacterFormatTest.java'
--- test/com/goldencode/p2j/util/AbstractCharacterFormatTest.java	2021-04-28 15:57:14 +0000
+++ test/com/goldencode/p2j/util/AbstractCharacterFormatTest.java	2022-09-19 15:25:47 +0000
@@ -63,7 +63,7 @@
 */
 package com.goldencode.p2j.util;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * This class provides common methods and data for all character parsing/formatting tests.

=== modified file 'test/com/goldencode/p2j/util/AbstractDateFormatTest.java'
--- test/com/goldencode/p2j/util/AbstractDateFormatTest.java	2021-09-17 15:14:10 +0000
+++ test/com/goldencode/p2j/util/AbstractDateFormatTest.java	2022-09-19 15:25:47 +0000
@@ -65,7 +65,7 @@
 
 import java.util.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 import com.goldencode.p2j.ui.client.format.*;
 

=== modified file 'test/com/goldencode/p2j/util/AbstractDatetimeFormatTest.java'
--- test/com/goldencode/p2j/util/AbstractDatetimeFormatTest.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/AbstractDatetimeFormatTest.java	2022-09-19 15:25:47 +0000
@@ -64,7 +64,7 @@
 */
 package com.goldencode.p2j.util;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Datetime-related tests helper class

=== modified file 'test/com/goldencode/p2j/util/AbstractLogicalFormatParseTest.java'
--- test/com/goldencode/p2j/util/AbstractLogicalFormatParseTest.java	2021-04-28 15:57:14 +0000
+++ test/com/goldencode/p2j/util/AbstractLogicalFormatParseTest.java	2022-09-19 15:25:47 +0000
@@ -61,7 +61,7 @@
 */
 package com.goldencode.p2j.util;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Common methods and data for all OE logical values parsing/formatting tests.

=== modified file 'test/com/goldencode/p2j/util/AbstractNumberFormatParseTest.java'
--- test/com/goldencode/p2j/util/AbstractNumberFormatParseTest.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/AbstractNumberFormatParseTest.java	2022-09-19 15:25:47 +0000
@@ -69,7 +69,7 @@
 
 import java.math.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Common fields and methods for testing 4gl number formats.

=== modified file 'test/com/goldencode/p2j/util/AbstractNumberFormatterTest.java'
--- test/com/goldencode/p2j/util/AbstractNumberFormatterTest.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/AbstractNumberFormatterTest.java	2022-09-19 15:41:59 +0000
@@ -64,11 +64,11 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.assertEquals;
+import static org.junit.jupiter.api.Assertions.assertEquals;
 
 import java.math.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Common fields and methods for testing formatting with 4gl number formats.

=== modified file 'test/com/goldencode/p2j/util/TestCharacterFormatParser.java'
--- test/com/goldencode/p2j/util/TestCharacterFormatParser.java	2021-09-17 15:14:10 +0000
+++ test/com/goldencode/p2j/util/TestCharacterFormatParser.java	2022-09-19 15:25:47 +0000
@@ -66,7 +66,7 @@
 
 import static org.junit.jupiter.api.Assertions.assertEquals;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for {@link CharacterFormatParser#parse(String)}

=== modified file 'test/com/goldencode/p2j/util/TestCharacterPreprocessFormatString.java'
--- test/com/goldencode/p2j/util/TestCharacterPreprocessFormatString.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/TestCharacterPreprocessFormatString.java	2022-09-19 15:42:28 +0000
@@ -67,10 +67,9 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.assertNotNull;
-import static org.junit.jupiter.api.Assertions.assertEquals;
+import static org.junit.jupiter.api.Assertions.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for {@link character#preprocessFormatString(String)}.

=== modified file 'test/com/goldencode/p2j/util/TestCharacterToStringFormatted.java'
--- test/com/goldencode/p2j/util/TestCharacterToStringFormatted.java	2021-04-28 15:57:14 +0000
+++ test/com/goldencode/p2j/util/TestCharacterToStringFormatted.java	2022-09-19 15:42:41 +0000
@@ -68,9 +68,9 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.assertNotNull;
+import static org.junit.jupiter.api.Assertions.assertNotNull;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for {@link character#toString(String)}.

=== modified file 'test/com/goldencode/p2j/util/TestCharacterValueOf.java'
--- test/com/goldencode/p2j/util/TestCharacterValueOf.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/TestCharacterValueOf.java	2022-09-19 15:42:51 +0000
@@ -67,9 +67,9 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.assertTrue;
+import static org.junit.jupiter.api.Assertions.assertTrue;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for {@link character#valueOf(String)}.

=== modified file 'test/com/goldencode/p2j/util/TestDateFormatParse.java'
--- test/com/goldencode/p2j/util/TestDateFormatParse.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/TestDateFormatParse.java	2022-09-19 18:25:39 +0000
@@ -68,9 +68,9 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.*;
+import static org.junit.jupiter.api.Assertions.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for parsing date format with {@link ParsedDateFormat#getInstance(String)}.
@@ -138,7 +138,7 @@
    /**
     * This method is called once by the test engine before all test methods in this class.
     */
-   @BeforeClass
+   @BeforeAll
    public static void beforeClass()
    {
       date.setDateOrder(AbstractDateFormatTest.ORDER_DMY);

=== modified file 'test/com/goldencode/p2j/util/TestDateFormatter.java'
--- test/com/goldencode/p2j/util/TestDateFormatter.java	2021-04-26 21:13:50 +0000
+++ test/com/goldencode/p2j/util/TestDateFormatter.java	2022-09-19 15:43:17 +0000
@@ -62,9 +62,9 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.assertEquals;
+import static org.junit.jupiter.api.Assertions.assertEquals;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for formatting dates.

=== modified file 'test/com/goldencode/p2j/util/TestDateFormatting.java'
--- test/com/goldencode/p2j/util/TestDateFormatting.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/TestDateFormatting.java	2022-09-19 15:50:47 +0000
@@ -63,9 +63,9 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.assertEquals;
+import static org.junit.jupiter.api.Assertions.assertEquals;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for formatting dates with {@link date#toString(String)}.
@@ -87,7 +87,7 @@
    /**
     * This method is called once by the test engine before all test methods in this class.
     */
-   @BeforeClass
+   @BeforeAll
    public static void beforeClass()
    {
       date.setDateOrder(AbstractDateFormatTest.ORDER_DMY);

=== modified file 'test/com/goldencode/p2j/util/TestDatetimeFormatting.java'
--- test/com/goldencode/p2j/util/TestDatetimeFormatting.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/TestDatetimeFormatting.java	2022-09-19 15:50:56 +0000
@@ -63,9 +63,9 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.assertEquals;
+import static org.junit.jupiter.api.Assertions.assertEquals;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for formatting with {@link datetime#toString(String)}
@@ -146,7 +146,7 @@
    /**
     * This method is called once by the test engine before all test methods in this class.
     */
-   @BeforeClass
+   @BeforeAll
    public static void beforeClass()
    {
       date.setDateOrder(AbstractDateFormatTest.ORDER_DMY);

=== modified file 'test/com/goldencode/p2j/util/TestLogicalSplitformat.java'
--- test/com/goldencode/p2j/util/TestLogicalSplitformat.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/TestLogicalSplitformat.java	2022-09-19 15:52:20 +0000
@@ -69,9 +69,9 @@
 package com.goldencode.p2j.util;
 
 import static com.goldencode.p2j.util.character.valueOf;
-import static org.junit.Assert.*;
+import static org.junit.jupiter.api.Assertions.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Tests for {@link logical#splitFormat(String)} and some related functions of {@link logical}.

=== modified file 'test/com/goldencode/p2j/util/TestNumberTypeParseFormat.java'
--- test/com/goldencode/p2j/util/TestNumberTypeParseFormat.java	2021-11-23 20:02:38 +0000
+++ test/com/goldencode/p2j/util/TestNumberTypeParseFormat.java	2022-09-19 15:52:35 +0000
@@ -68,9 +68,9 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.*;
+import static org.junit.jupiter.api.Assertions.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 import com.goldencode.p2j.util.NumberType.*;
 

=== modified file 'test/com/goldencode/p2j/util/TestRowid.java'
--- test/com/goldencode/p2j/util/TestRowid.java	2021-09-17 15:14:10 +0000
+++ test/com/goldencode/p2j/util/TestRowid.java	2022-09-19 15:51:13 +0000
@@ -64,12 +64,12 @@
 */
 package com.goldencode.p2j.util;
 
-import static org.junit.Assert.assertNull;
+import static org.junit.jupiter.api.Assertions.assertNull;
 import static org.junit.jupiter.api.Assertions.assertEquals;
 
 import java.util.function.*;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Various tests for ROWID parsing and formatting. Includes tests for

=== modified file 'test/com/goldencode/util/TestPrintable.java'
--- test/com/goldencode/util/TestPrintable.java	2022-03-07 22:24:50 +0000
+++ test/com/goldencode/util/TestPrintable.java	2022-09-19 15:25:47 +0000
@@ -64,7 +64,7 @@
 
 import static org.junit.jupiter.api.Assertions.assertEquals;
 
-import org.junit.*;
+import org.junit.jupiter.api.*;
 
 /**
  * Test classes, which implement {@link Printable} interface.