=== added directory 'src/com/goldencode/p2j/client'
=== added file 'src/com/goldencode/p2j/client/UnitTestExports.java'
--- src/com/goldencode/p2j/client/UnitTestExports.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/client/UnitTestExports.java	2022-09-27 12:52:55 +0000
@@ -0,0 +1,16 @@
+/**
+ * 
+ */
+package com.goldencode.p2j.client;
+
+/**
+ * Interface to support FWD unit testing engine remote operation.
+ */
+public interface UnitTestExports
+{
+   /**
+    * Temporary, as an experiment 
+    */
+   public void sayHello();
+   
+}

=== modified file 'src/com/goldencode/p2j/main/ClientCore.java'
--- src/com/goldencode/p2j/main/ClientCore.java	2022-09-18 16:13:54 +0000
+++ src/com/goldencode/p2j/main/ClientCore.java	2022-09-27 16:56:48 +0000
@@ -121,6 +121,7 @@
 import java.util.logging.*;
 
 import com.goldencode.p2j.cfg.*;
+import com.goldencode.p2j.client.*;
 import com.goldencode.p2j.net.*;
 import com.goldencode.p2j.directory.*;
 import com.goldencode.p2j.security.SecurityManager;
@@ -357,6 +358,32 @@
          // set up current user name for client session
          ThinClient.getInstance().setUserName(params.osUserName);
 
+         // This remote call goes OK
+         final RemoteErrorData red = (RemoteErrorData) RemoteObject
+                  .obtainNetworkInstance(RemoteErrorData.class);
+         red.isSilent();
+         
+         // And this one throws "Unresolvable remote export..." error
+         final BatchProcess bp = (BatchProcess) RemoteObject
+                  .obtainNetworkInstance(BatchProcess.class);
+         try
+         {
+            bp.launch("bla-bla");
+         }
+         catch (Throwable e)
+         {
+            System.err.println(e);
+         }
+         
+         // This one either throws "Unresolvable remote export.." error
+         final UnitTestExports unitTestSupport = (UnitTestExports) RemoteObject
+                  .obtainNetworkInstance(UnitTestExports.class, session);       
+         try {
+            unitTestSupport.sayHello();
+         } catch (Throwable e) {
+            System.err.println(e);
+         }
+         
          // call the application
          running = main.standardEntry();
          

=== modified file 'src/com/goldencode/p2j/main/StandardServer.java'
--- src/com/goldencode/p2j/main/StandardServer.java	2022-05-16 07:25:30 +0000
+++ src/com/goldencode/p2j/main/StandardServer.java	2022-09-27 13:50:08 +0000
@@ -271,6 +271,7 @@
 import com.goldencode.p2j.cfg.*;
 import com.goldencode.p2j.cfg.Configuration;
 import com.goldencode.p2j.classloader.*;
+import com.goldencode.p2j.client.*;
 import com.goldencode.p2j.directory.*;
 import com.goldencode.p2j.net.*;
 import com.goldencode.p2j.persist.*;
@@ -280,6 +281,7 @@
 import com.goldencode.p2j.security.*;
 import com.goldencode.p2j.security.SecurityManager;
 import com.goldencode.p2j.soap.*;
+import com.goldencode.p2j.testengine.*;
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.util.*;
 import com.goldencode.p2j.util.ErrorManager;
@@ -985,7 +987,9 @@
       
       ifaces = new Class[] { ServerPropertiesInspector.class };
       RemoteObject.registerStaticNetworkServer(ifaces, ServerPropertiesDaemon.class);
-      
+            
+      RemoteObject.registerStaticNetworkServer(new Class[] { UnitTestExports.class }, UnitTestServer.class);
+
       AdminServerImpl.initialize();
       
       DirectoryManager.initServer();
@@ -1107,7 +1111,7 @@
     * @param   ds
     *          The directory service.
     */
-   private void initClassLoaders(DirectoryService ds)
+   private static void initClassLoaders(DirectoryService ds)
    {
       // initialize the class loaders for the jars defined in the directory
       String path = Utils.findDirectoryNodePath(ds,

=== added directory 'src/com/goldencode/p2j/testengine'
=== added file 'src/com/goldencode/p2j/testengine/UnitTestServer.java'
--- src/com/goldencode/p2j/testengine/UnitTestServer.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/UnitTestServer.java	2022-09-27 13:50:09 +0000
@@ -0,0 +1,20 @@
+package com.goldencode.p2j.testengine;
+
+import com.goldencode.p2j.client.*;
+
+/**
+ * FWD unit testing engine remote operation server-side implementation.
+ * Contains static method implementing {@link UnitTestExports} interface.
+ */
+public class UnitTestServer
+{
+
+   /**
+    * 
+    */
+   public static void sayHello()
+   {
+      System.err.println("Hello!");
+   }
+
+}